//---------------------------------------------------------------------------

#ifndef ChartDonutH
#define ChartDonutH

#include <VCLTee.Chart.hpp>
#include <VCLTee.TeeDonut.hpp>
#include <VCLTee.TeeTools.hpp>
#include <vector>

//---------------------------------------------------------------------------
class DonutChart
{
private:
	TChart *_chart;
	UnicodeString _title;
	TDonutSeries *_serie;

	std::vector<TColor>_colorVect;

	void InitChart();
	void ConfigMarks();
	void ConfigMarksTipTool();
	void __fastcall OnMouseOverSerie(TMarksTipTool* pSender, System::UnicodeString& pText);

public:
	DonutChart(TChart &pChart, UnicodeString pTitle);
	void AddData(int piValue, UnicodeString const & pMarkText);
	void AddRandomData(int iMax = 100);
	static std::vector<TColor>InitColorLst();
	void MoveMarks();
};

#endif
