//---------------------------------------------------------------------------

#pragma hdrstop

#include "MultiChart.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)

MultiChart::MultiChart(TChart &pParentChart)
{
	pParentChart.ClearChart();
	_subChartTool = new TSubChartTool(&pParentChart);
	_subChartTool->ParentChart = &pParentChart;

	pParentChart.AxisVisible = false;
	pParentChart.Frame->Visible = false;
	pParentChart.View3DWalls = false;
	pParentChart.BevelOuter = bvNone;

	pParentChart.Gradient->Visible = false;
	pParentChart.Color = (TColor)RGB(240, 240, 240);

	pParentChart.OnResize = OnChartResize;
}

MultiChart::~MultiChart()
{
	_subChartTool->Charts->Clear();
}

TChart* MultiChart::AddChart()
{
	TChart *chart = NULL;
	chart = _subChartTool->Charts->AddChart("SubChart" + IntToStr(_subChartTool->Charts->Count));
	chart->Parent = _subChartTool->ParentChart->Parent;
	PlaceSubCharts();
	return chart;
}

void __fastcall MultiChart::OnChartResize(TObject *Sender)
{
	PlaceSubCharts();
}

void MultiChart::PlaceSubCharts()
{
	int i, iOffsetY, iDeltaOffsetY = 5;
	double dCoeff1 = 0.5, dCoeff2 = 0.5;

	//1stChart
	_subChartTool->Charts->Items[0]->Top = 0;
	_subChartTool->Charts->Items[0]->Height = _subChartTool->ParentChart->Height * dCoeff1;
	_subChartTool->Charts->Items[0]->Left = 0;
	_subChartTool->Charts->Items[0]->Width = _subChartTool->ParentChart->Width;
	//otherCharts
	if (_subChartTool->Charts->Count > 1)
	{
		iOffsetY = _subChartTool->Charts->Items[0]->Top + _subChartTool->Charts->Items[0]->Height + iDeltaOffsetY;
		int iEqualWidth = (_subChartTool->ParentChart->Width - 0) / (_subChartTool->Charts->Count - 1);
		for (i = 1; i < _subChartTool->Charts->Count; i++)
		{
			_subChartTool->Charts->Items[i]->Top = iOffsetY;
			_subChartTool->Charts->Items[i]->Height = (_subChartTool->ParentChart->Height * dCoeff2) - iDeltaOffsetY * 0;
			_subChartTool->Charts->Items[i]->Left = (i - 1) * iEqualWidth + (i > 1 ? 1 : 0);
			_subChartTool->Charts->Items[i]->Width = iEqualWidth;
		}
	}
}
